#include "network_config.hh"

namespace network_config
{
  /* skeleton
  class : public kvtree::LineFactoryInstance
  { 
  public:
    virtual bool Match (std::string& content, kvtree::TreeManager* manager);

  private:
    Subsection* GetSubsection (kvtree::TreeManager* manager);
  };
  */

  extern std::vector <std::string> tokens;

  class DeComment : public kvtree::LineFactoryInstance
  { // strips comments and leading tabs / spaces
    // if the remaining line is empty the Match method returns true so it is removed 
  public:
    // i adapt the behavior of rocknet, that is simulating the expression
    //                      s,\(^\|[ \t]\)#.*$,,
    // ( comments either start with "#" at beginning of line or with "\t#" )
    virtual bool Match (std::string& content, kvtree::TreeManager* manager);
  };


  class InterfaceSectionInstance: public kvtree::LineFactoryInstance
  { 
  public:
    virtual bool Match (std::string& content, kvtree::TreeManager* manager);
  };

  class AddressSubsectionInstance: public kvtree::LineFactoryInstance
  {
  public:
    virtual bool Match (std::string& content, kvtree::TreeManager* manager);

  private:
    AddressSubsection* GetAddressSubsection (kvtree::TreeManager* manager);
  };

  class WirelessSubsectionInstance: public kvtree::LineFactoryInstance
  { 
  public:
    virtual bool Match (std::string& content, kvtree::TreeManager* manager);
  
  private:
    WirelessSubsection* GetWirelessSubsection (kvtree::TreeManager* manager);
  };

  class PPPSubsectionInstance: public kvtree::LineFactoryInstance
  { 
  public:
    virtual bool Match (std::string& content, kvtree::TreeManager* manager);

  private:
    PPPSubsection* GetPPPSubsection (kvtree::TreeManager* manager);
  };


  class SortRemainingInstance: public kvtree::LineFactoryInstance
  {
  public: // ensures that all unknown tokens either sort into interface or global section
    virtual bool Match (std::string& content, kvtree::TreeManager* manager);
  
  };

}
