#include <qstring.h>
#include <klocale.h>
#include "chat_auth_box.hh"

ChatAuthBox::ChatAuthBox (QWidget* parent)
  : QButtonGroup (parent)
{
  config = 0;
  setColumnLayout (2, Qt::Horizontal);
  user_label = new QLabel (this);
  user_label -> setText (i18n("user"));
  user = new KLineEdit ("", this);

  passwd_label = new QLabel (this);
  passwd_label -> setText (i18n("password"));
  passwd = new KLineEdit ("", this);
  passwd -> setEchoMode (QLineEdit::Password);

  QObject::connect ( user, SIGNAL( textChanged (const QString&) ), this, SLOT ( changeUser (const QString& ) ));
  QObject::connect ( passwd, SIGNAL( textChanged (const QString&) ), this, SLOT ( changePasswd (const QString& ) ));
}

void ChatAuthBox::NewConfig (network_config::PPPSubsection* subsection)
{
  config = subsection;

  network_config::OptionLine* user_option;
  user_option = config -> Option ("user", true);
  user -> setText (user_option -> value.c_str());

  network_config::OptionLine* passwd_option;
  passwd_option = config -> Option ("password", true);
  passwd -> setText (passwd_option -> value.c_str());
}

void ChatAuthBox::changeUser (const QString& new_user)
{
  if (!config)
    return;
  network_config::OptionLine* user_option = config -> Option ("user");
  user_option -> value = new_user;
  user_option -> Set ();
  std::cout << user_option -> line << std::endl;
}

void ChatAuthBox::changePasswd (const QString& new_passwd)
{
  if (!config)
    return;
  network_config::OptionLine* passwd_option = config -> Option ("password");
  passwd_option -> value = new_passwd;
  passwd_option -> Set ();
  std::cout << passwd_option -> line << std::endl;
}

