#include <qtabwidget.h>
#include <vector>
#include "device.hh"

class EtherDev;
class QComboBox;
class ChatAuthBox;
class PPPAnalogTab;
class PPPOETab;
class ModemStatus;

class PPPDevice : public Device
{
  Q_OBJECT
public:
  PPPDevice  (const QString& interface, DeviceManager* device_manager, ProfileManager* profile_manager);

  virtual QPixmap* GetEnabledPicture ();
  virtual QPixmap* GetDisabledPicture ();
  virtual const QString& GetName ();
  virtual const QString& GetTitle ();

  virtual QWidget* CreateStatus (QWidget* parent);

protected:
  virtual void BuildContent (QVBox* box);
  virtual void RefreshContent ();  
  virtual void EnabledToggled ();
  virtual void ActiveToggled (bool state);

private slots:
  void selectionChanged (int item); // by ComboBox

private:
  void PPPDevice::SetPPPOE (bool value); // by refreshContent()
  void SwitchType ();  // common stuff by selectionChanged / SetPPPOE

  QString title;
  QString iface;
  QPixmap* enabled;
  QPixmap* disabled;

  QComboBox* type;
  QTabWidget* main_tab;
  PPPAnalogTab* pa_tab;
  PPPOETab* poe_tab;
  ChatAuthBox* ca_tab;

  ModemStatus* status;

  bool allow_pppoe;
  std::vector <EtherDev*> pppoe_devs;

  bool PPPOE ();

};
